{% extends "ajax/ajax_plain.html.twig" %}
{% block ajax_base %}
    {# @var posts \App\Entity\Post[] #}

    {% if posts is empty %}
        <div class="note">{{ 'Es wurden keine Nachrichten gefunden, die deiner Suchanfrage entsprechen.'|trans({},'global') }}</div>
    {% endif %}

    <div class="forum-posts">
        {% for post in posts %}
            {% set variant = null %}
            {% if post.owner.name == 'Der Rabe' %}{% set variant = 'crow' %}
            {% elseif post.type != "USER" and post.type is not null %}{% set variant = post.type|lower %}{% endif %}

            <div class="forum-post {% if variant is not null %}forum-post-variant-{{ variant }}{% endif %} forum-post-search-result" id="{{post.id}}">
                <div class="forum-post-header {% if variant is not null %}header-variant-{{ variant }}{% endif %}">
                    <i>
                        {% if post.date >= 'today'|to_date %}
                            {{ 'Heute um'|trans({},'global') }} {{ post.date|format_datetime('none', 'short') }}
                        {% elseif post.date >= 'yesterday'|to_date %}
                            {{ 'Gestern um'|trans({},'global') }} {{ post.date|format_datetime('none', 'short') }}
                        {% else %}
                            {{ post.date|format_datetime('medium', 'short') }}
                        {% endif %}
                    </i>
                    {% if (post.owner.avatar) %}
                        {% if post.owner.name == 'Der Rabe' %}
                            <div class="avatarcrow small"><img alt="" src="{{ asset('build/images/forum/crow/crow.small.' ~ (app.request.locale|e('html_attr')|split('_', 2))[0] ~ '.png') }}"></div>
                        {% else %}
                            <div class="avatar small ua-{{ random(0,9) }}"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.smallName, 'ext': post.owner.avatar.format}) }}"></div>
                        {% endif %}
                    {% else %}
                        <div class="avatar small ua-{{ random(0,9) }}"><img alt="" src="{{ asset('build/images/forum/empty_avatar.gif') }}"></div>
                    {% endif %}
                    {% include 'ajax/soul/playername.html.twig' with {user: post.owner, globalSpace: post.thread.forum.town is null} only %}
                    <div class="found-in">{{ post.searchForum.title }} <i class="fa fa-caret-right"></i> <a x-ajax-href="{{ path('forum_jump_view', {pid: post.id}) }}" x-ajax-transient x-ajax-target="#content" >{{ post.thread.translatable ? post.thread.title|trans({},'game') : post.thread.title }}</a></div>
                </div>
                <div class="forum-post-content">
                    {{ post.translate ? (post.text|trans({},'game')|raw) : (post.text|raw) }}
                </div>
            </div>
        {% endfor %}
    </div>

    {% if more %}
        <div class="note">{{ 'Deine Suchanfrage hat mehr Ergebnisse geliefert, als hier angezeigt werden können. Versuche, deine Anfrage zu präzisieren, wenn du nicht gefunden hast wonach du suchst.'|trans({},'global') }}</div>
    {% endif %}
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        const hl = function (node,find) {
            const like_find = find.normalize("NFD").replace(/[\u0300-\u036f]/g, "").toLowerCase();

            if (node.nodeType === Node.TEXT_NODE) {

                let text = node.textContent;
                let like_text = text.normalize("NFD").replace(/[\u0300-\u036f]/g, "").toLowerCase();

                let index;
                while ((index = like_text.indexOf( like_find )) >= 0) {
                    const text_before = document.createTextNode( text.substr(0,index) );
                    const highlight = $.html.createElement('<span class="search-anchor" />', text.substr(index,find.length));
                    like_text = (node.textContent = text = text.substr( index + find.length )).normalize("NFD").replace(/[\u0300-\u036f]/g, "");
                    if (index > 0) node.parentNode.insertBefore( text_before, node )
                    node.parentNode.insertBefore( highlight, node )
                    if (text.length === 0) node.remove();
                }

            } else if (node.nodeType === Node.ELEMENT_NODE && (node.tagName !== 'SPAN' || !node.classList.contains('search-anchor'))) {
                let children = node.childNodes;
                for (let i = 0; i < children.length; i++) hl(children[i],find);
            }
        }

        $.html.forEach('.forum-post-search-result .forum-post-content', element => {
            {% for text in highlight %}
                hl(element,'{{ text|e('js') }}');
            {% endfor %}
        });

        $.html.forEach('.forum-post-search-result .forum-post-content', element => {
            let e = element.clientHeight !== element.scrollHeight ? element.querySelector('span.search-anchor') : null;
            if (e) {
                let ot = 0, op = e;
                while (op !== element.offsetParent || op === null) {
                    ot += op.offsetTop;
                    op = op.offsetParent;
                }

                const p = Math.max(0, ot - element.offsetTop + e.offsetHeight / 2 - element.clientHeight / 2);
                element.scrollTo(0, p);
            }
        });
    </script>
{% endblock %}